/* client.c generated by valac 0.56.17, the Vala compiler
 * generated from client.vala, do not modify */

/*
 * Copyright (C) 2012 Daiki Ueno <ueno@unixuser.org>
 * Copyright (C) 2012 Red Hat, Inc.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <glib.h>
#include <string.h>
#include <libfep-glib/libfep-glib.h>
#include <ibus.h>
#include <stdlib.h>
#include <gio/gio.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	PREEDIT_STYLE_OVER_THE_SPOT,
	PREEDIT_STYLE_ROOT,
	PREEDIT_STYLE_DEFAULT = PREEDIT_STYLE_OVER_THE_SPOT
} PreeditStyle;

#define TYPE_PREEDIT_STYLE (preedit_style_get_type ())

#define TYPE_OPTIONS (options_get_type ())
typedef struct _Options Options;

#define TYPE_CLIENT (client_get_type ())
#define CLIENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CLIENT, Client))
#define CLIENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CLIENT, ClientClass))
#define IS_CLIENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CLIENT))
#define IS_CLIENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CLIENT))
#define CLIENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CLIENT, ClientClass))

typedef struct _Client Client;
typedef struct _ClientClass ClientClass;
typedef struct _ClientPrivate ClientPrivate;
enum  {
	CLIENT_0_PROPERTY,
	CLIENT_NUM_PROPERTIES
};
static GParamSpec* client_properties[CLIENT_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_FepGAttribute_free0(var) ((var == NULL) ? NULL : (var = (_vala_FepGAttribute_free (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
typedef struct _Block1Data Block1Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_io_channel_unref0(var) ((var == NULL) ? NULL : (var = (g_io_channel_unref (var), NULL)))

struct _Options {
	PreeditStyle preedit_style;
};

struct _Client {
	FepGClient parent_instance;
	ClientPrivate * priv;
};

struct _ClientClass {
	FepGClientClass parent_class;
};

struct _ClientPrivate {
	IBusInputContext* context;
	IBusLookupTable* lookup_table;
	gboolean preedit_visible;
	gboolean lookup_table_visible;
	Options opts;
	gchar* preedit;
	FepGAttribute* preedit_attr;
	gchar* status;
	FepGAttribute* status_attr;
};

struct _Block1Data {
	int _ref_count_;
	Client* self;
	IBusBus* bus;
};

static gint Client_private_offset;
static gpointer client_parent_class = NULL;

VALA_EXTERN GType preedit_style_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType options_get_type (void) G_GNUC_CONST ;
VALA_EXTERN Options* options_dup (const Options* self);
VALA_EXTERN void options_free (Options* self);
VALA_EXTERN GType client_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Client, g_object_unref)
static void _vala_FepGAttribute_free (FepGAttribute* self);
static void _client_ibus_commit_text (Client* self,
                               IBusText* text);
static void _client_ibus_show_preedit_text (Client* self);
static FepGAttribute* _vala_FepGAttribute_copy (FepGAttribute* self);
static void _client_ibus_hide_preedit_text (Client* self);
static void client_update_status (Client* self);
static void _client_ibus_update_preedit_text (Client* self,
                                       IBusText* text,
                                       guint cursor_pos,
                                       gboolean visible);
static gboolean _fep_g_attribute_equal (const FepGAttribute * s1,
                                 const FepGAttribute * s2);
static gchar* client_format_indicator (Client* self);
static void _client_ibus_show_lookup_table (Client* self);
static void _client_ibus_hide_lookup_table (Client* self);
static void _client_ibus_update_lookup_table (Client* self,
                                       IBusLookupTable* lookup_table,
                                       gboolean visible);
static void _client_ibus_global_engine_changed (Client* self,
                                         const gchar* name);
static gboolean client_real_filter_key_event (FepGClient* base,
                                       guint keyval,
                                       guint modifiers);
static gboolean client_watch_func (Client* self,
                            GIOChannel* source,
                            GIOCondition condition);
static void client_create_input_context_done (Client* self);
static void __client_ibus_commit_text_ibus_input_context_commit_text (IBusInputContext* _sender,
                                                               IBusText* p0,
                                                               gpointer self);
static void __client_ibus_show_preedit_text_ibus_input_context_show_preedit_text (IBusInputContext* _sender,
                                                                           gpointer self);
static void __client_ibus_hide_preedit_text_ibus_input_context_hide_preedit_text (IBusInputContext* _sender,
                                                                           gpointer self);
static void __client_ibus_update_preedit_text_ibus_input_context_update_preedit_text (IBusInputContext* _sender,
                                                                               IBusText* p0,
                                                                               guint p1,
                                                                               gboolean p2,
                                                                               gpointer self);
static void __client_ibus_show_lookup_table_ibus_input_context_show_lookup_table (IBusInputContext* _sender,
                                                                           gpointer self);
static void __client_ibus_hide_lookup_table_ibus_input_context_hide_lookup_table (IBusInputContext* _sender,
                                                                           gpointer self);
static void __client_ibus_update_lookup_table_ibus_input_context_update_lookup_table (IBusInputContext* _sender,
                                                                               IBusLookupTable* p0,
                                                                               gboolean p1,
                                                                               gpointer self);
VALA_EXTERN Client* client_new (IBusBus* bus,
                    Options* opts,
                    GError** error);
VALA_EXTERN Client* client_construct (GType object_type,
                          IBusBus* bus,
                          Options* opts,
                          GError** error);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static void __client_ibus_global_engine_changed_ibus_bus_global_engine_changed (IBusBus* _sender,
                                                                         const gchar* p0,
                                                                         gpointer self);
static void __lambda4_ (Block1Data* _data1_,
                 GObject* obj,
                 GAsyncResult* res);
static void ___lambda4__gasync_ready_callback (GObject* source_object,
                                        GAsyncResult* res,
                                        gpointer self);
static gboolean _client_watch_func_gio_func (GIOChannel* source,
                                      GIOCondition condition,
                                      gpointer self);
static void client_finalize (GObject * obj);
static GType client_get_type_once (void);

static GType
preedit_style_get_type_once (void)
{
	static const GEnumValue values[] = {{PREEDIT_STYLE_OVER_THE_SPOT, "PREEDIT_STYLE_OVER_THE_SPOT", "over-the-spot"}, {PREEDIT_STYLE_ROOT, "PREEDIT_STYLE_ROOT", "root"}, {PREEDIT_STYLE_DEFAULT, "PREEDIT_STYLE_DEFAULT", "default"}, {0, NULL, NULL}};
	GType preedit_style_type_id;
	preedit_style_type_id = g_enum_register_static ("PreeditStyle", values);
	return preedit_style_type_id;
}

GType
preedit_style_get_type (void)
{
	static volatile gsize preedit_style_type_id__once = 0;
	if (g_once_init_enter (&preedit_style_type_id__once)) {
		GType preedit_style_type_id;
		preedit_style_type_id = preedit_style_get_type_once ();
		g_once_init_leave (&preedit_style_type_id__once, preedit_style_type_id);
	}
	return preedit_style_type_id__once;
}

Options*
options_dup (const Options* self)
{
	Options* dup;
#line 25 "client.vala"
	dup = g_new0 (Options, 1);
#line 25 "client.vala"
	memcpy (dup, self, sizeof (Options));
#line 25 "client.vala"
	return dup;
#line 226 "client.c"
}

void
options_free (Options* self)
{
#line 25 "client.vala"
	g_free (self);
#line 234 "client.c"
}

static GType
options_get_type_once (void)
{
	GType options_type_id;
	options_type_id = g_boxed_type_register_static ("Options", (GBoxedCopyFunc) options_dup, (GBoxedFreeFunc) options_free);
	return options_type_id;
}

GType
options_get_type (void)
{
	static volatile gsize options_type_id__once = 0;
	if (g_once_init_enter (&options_type_id__once)) {
		GType options_type_id;
		options_type_id = options_get_type_once ();
		g_once_init_leave (&options_type_id__once, options_type_id);
	}
	return options_type_id__once;
}

static inline gpointer
client_get_instance_private (Client* self)
{
	return G_STRUCT_MEMBER_P (self, Client_private_offset);
}

static void
_vala_FepGAttribute_free (FepGAttribute* self)
{
#line 37 "client.vala"
	g_boxed_free (fep_g_attribute_get_type (), self);
#line 268 "client.c"
}

static void
_client_ibus_commit_text (Client* self,
                          IBusText* text)
{
	gchar* str = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
#line 45 "client.vala"
	g_return_if_fail (self != NULL);
#line 45 "client.vala"
	g_return_if_fail (text != NULL);
#line 46 "client.vala"
	_tmp0_ = ibus_text_get_text (text);
#line 46 "client.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 46 "client.vala"
	str = _tmp1_;
#line 47 "client.vala"
	_tmp2_ = str;
#line 47 "client.vala"
	_tmp3_ = strlen (_tmp2_);
#line 47 "client.vala"
	_tmp4_ = _tmp3_;
#line 47 "client.vala"
	if (_tmp4_ > 0) {
#line 299 "client.c"
		const gchar* _tmp5_;
#line 48 "client.vala"
		_tmp5_ = str;
#line 48 "client.vala"
		fep_g_client_send_text ((FepGClient*) self, _tmp5_);
#line 305 "client.c"
	}
#line 45 "client.vala"
	_g_free0 (str);
#line 309 "client.c"
}

static FepGAttribute*
_vala_FepGAttribute_copy (FepGAttribute* self)
{
#line 55 "client.vala"
	return g_boxed_copy (fep_g_attribute_get_type (), self);
#line 317 "client.c"
}

static gpointer
__vala_FepGAttribute_copy0 (gpointer self)
{
#line 55 "client.vala"
	return self ? _vala_FepGAttribute_copy (self) : NULL;
#line 325 "client.c"
}

static void
_client_ibus_show_preedit_text (Client* self)
{
	Options _tmp0_;
#line 51 "client.vala"
	g_return_if_fail (self != NULL);
#line 52 "client.vala"
	_tmp0_ = self->priv->opts;
#line 52 "client.vala"
	if (_tmp0_.preedit_style == PREEDIT_STYLE_ROOT) {
#line 338 "client.c"
		const gchar* _tmp1_;
		FepGAttribute* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		FepGAttribute* _tmp5_;
		FepGAttribute* _tmp6_;
#line 53 "client.vala"
		_tmp1_ = self->priv->preedit;
#line 53 "client.vala"
		_tmp2_ = self->priv->preedit_attr;
#line 53 "client.vala"
		fep_g_client_set_status_text ((FepGClient*) self, _tmp1_, _tmp2_);
#line 54 "client.vala"
		_tmp3_ = self->priv->preedit;
#line 54 "client.vala"
		_tmp4_ = g_strdup (_tmp3_);
#line 54 "client.vala"
		_g_free0 (self->priv->status);
#line 54 "client.vala"
		self->priv->status = _tmp4_;
#line 55 "client.vala"
		_tmp5_ = self->priv->preedit_attr;
#line 55 "client.vala"
		_tmp6_ = __vala_FepGAttribute_copy0 (_tmp5_);
#line 55 "client.vala"
		__vala_FepGAttribute_free0 (self->priv->status_attr);
#line 55 "client.vala"
		self->priv->status_attr = _tmp6_;
#line 367 "client.c"
	} else {
		const gchar* _tmp7_;
		FepGAttribute* _tmp8_;
#line 57 "client.vala"
		_tmp7_ = self->priv->preedit;
#line 57 "client.vala"
		_tmp8_ = self->priv->preedit_attr;
#line 57 "client.vala"
		fep_g_client_set_cursor_text ((FepGClient*) self, _tmp7_, _tmp8_);
#line 377 "client.c"
	}
#line 58 "client.vala"
	self->priv->preedit_visible = TRUE;
#line 381 "client.c"
}

static void
_client_ibus_hide_preedit_text (Client* self)
{
	Options _tmp0_;
#line 61 "client.vala"
	g_return_if_fail (self != NULL);
#line 62 "client.vala"
	_tmp0_ = self->priv->opts;
#line 62 "client.vala"
	if (_tmp0_.preedit_style == PREEDIT_STYLE_ROOT) {
#line 63 "client.vala"
		client_update_status (self);
#line 396 "client.c"
	} else {
#line 65 "client.vala"
		fep_g_client_set_cursor_text ((FepGClient*) self, "", NULL);
#line 400 "client.c"
	}
#line 66 "client.vala"
	self->priv->preedit_visible = FALSE;
#line 404 "client.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 74 "client.vala"
	return self ? g_object_ref (self) : NULL;
#line 412 "client.c"
}

static gboolean
_fep_g_attribute_equal (const FepGAttribute * s1,
                        const FepGAttribute * s2)
{
#line 87 "client.vala"
	if (s1 == s2) {
#line 87 "client.vala"
		return TRUE;
#line 423 "client.c"
	}
#line 87 "client.vala"
	if (s1 == NULL) {
#line 87 "client.vala"
		return FALSE;
#line 429 "client.c"
	}
#line 87 "client.vala"
	if (s2 == NULL) {
#line 87 "client.vala"
		return FALSE;
#line 435 "client.c"
	}
#line 87 "client.vala"
	if (s1->type != s2->type) {
#line 87 "client.vala"
		return FALSE;
#line 441 "client.c"
	}
#line 87 "client.vala"
	if (s1->value != s2->value) {
#line 87 "client.vala"
		return FALSE;
#line 447 "client.c"
	}
#line 87 "client.vala"
	if (s1->start_index != s2->start_index) {
#line 87 "client.vala"
		return FALSE;
#line 453 "client.c"
	}
#line 87 "client.vala"
	if (s1->end_index != s2->end_index) {
#line 87 "client.vala"
		return FALSE;
#line 459 "client.c"
	}
#line 87 "client.vala"
	return TRUE;
#line 463 "client.c"
}

static void
_client_ibus_update_preedit_text (Client* self,
                                  IBusText* text,
                                  guint cursor_pos,
                                  gboolean visible)
{
	gchar* _preedit = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	IBusAttrList* attrs = NULL;
	IBusAttrList* _tmp2_;
	IBusAttrList* _tmp3_;
	FepGAttribute* attr = NULL;
	gboolean _tmp16_ = FALSE;
	gboolean _tmp17_ = FALSE;
	const gchar* _tmp18_;
	const gchar* _tmp19_;
#line 69 "client.vala"
	g_return_if_fail (self != NULL);
#line 69 "client.vala"
	g_return_if_fail (text != NULL);
#line 73 "client.vala"
	_tmp0_ = ibus_text_get_text (text);
#line 73 "client.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 73 "client.vala"
	_preedit = _tmp1_;
#line 74 "client.vala"
	_tmp2_ = ibus_text_get_attributes (text);
#line 74 "client.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 74 "client.vala"
	attrs = _tmp3_;
#line 75 "client.vala"
	attr = NULL;
#line 501 "client.c"
	{
		gint i = 0;
#line 76 "client.vala"
		i = 0;
#line 506 "client.c"
		{
			gboolean _tmp4_ = FALSE;
#line 76 "client.vala"
			_tmp4_ = TRUE;
#line 76 "client.vala"
			while (TRUE) {
#line 513 "client.c"
				IBusAttrList* _tmp6_;
				GArray* _tmp7_;
				IBusAttribute* _attr = NULL;
				IBusAttrList* _tmp8_;
				IBusAttribute* _tmp9_;
				IBusAttribute* _tmp10_;
				IBusAttribute* _tmp11_;
#line 76 "client.vala"
				if (!_tmp4_) {
#line 523 "client.c"
					gint _tmp5_;
#line 76 "client.vala"
					_tmp5_ = i;
#line 76 "client.vala"
					i = _tmp5_ + 1;
#line 529 "client.c"
				}
#line 76 "client.vala"
				_tmp4_ = FALSE;
#line 76 "client.vala"
				_tmp6_ = attrs;
#line 76 "client.vala"
				_tmp7_ = _tmp6_->attributes;
#line 76 "client.vala"
				if (!(((guint) i) < _tmp7_->len)) {
#line 76 "client.vala"
					break;
#line 541 "client.c"
				}
#line 77 "client.vala"
				_tmp8_ = attrs;
#line 77 "client.vala"
				_tmp9_ = ibus_attr_list_get (_tmp8_, (guint) i);
#line 77 "client.vala"
				_tmp10_ = _g_object_ref0 (_tmp9_);
#line 77 "client.vala"
				_attr = _tmp10_;
#line 78 "client.vala"
				_tmp11_ = _attr;
#line 78 "client.vala"
				if (_tmp11_->type == ((guint) IBUS_ATTR_TYPE_UNDERLINE)) {
#line 555 "client.c"
					IBusAttribute* _tmp12_;
					IBusAttribute* _tmp13_;
					FepGAttribute _tmp14_ = {0};
					FepGAttribute* _tmp15_;
#line 79 "client.vala"
					_tmp12_ = _attr;
#line 79 "client.vala"
					_tmp13_ = _attr;
#line 79 "client.vala"
					memset (&_tmp14_, 0, sizeof (FepGAttribute));
#line 79 "client.vala"
					_tmp14_.type = FEP_G_ATTR_TYPE_UNDERLINE;
#line 79 "client.vala"
					_tmp14_.value = (guint) FEP_G_ATTR_UNDERLINE_SINGLE;
#line 79 "client.vala"
					_tmp14_.start_index = _tmp12_->start_index;
#line 79 "client.vala"
					_tmp14_.end_index = _tmp13_->end_index;
#line 79 "client.vala"
					_tmp15_ = __vala_FepGAttribute_copy0 (&_tmp14_);
#line 79 "client.vala"
					__vala_FepGAttribute_free0 (attr);
#line 79 "client.vala"
					attr = _tmp15_;
#line 580 "client.c"
				}
#line 76 "client.vala"
				_g_object_unref0 (_attr);
#line 584 "client.c"
			}
		}
	}
#line 87 "client.vala"
	_tmp18_ = self->priv->preedit;
#line 87 "client.vala"
	_tmp19_ = _preedit;
#line 87 "client.vala"
	if (g_strcmp0 (_tmp18_, _tmp19_) != 0) {
#line 87 "client.vala"
		_tmp17_ = TRUE;
#line 596 "client.c"
	} else {
		FepGAttribute* _tmp20_;
		FepGAttribute* _tmp21_;
#line 87 "client.vala"
		_tmp20_ = self->priv->preedit_attr;
#line 87 "client.vala"
		_tmp21_ = attr;
#line 87 "client.vala"
		_tmp17_ = _fep_g_attribute_equal (_tmp20_, _tmp21_) != TRUE;
#line 606 "client.c"
	}
#line 87 "client.vala"
	if (_tmp17_) {
#line 87 "client.vala"
		_tmp16_ = TRUE;
#line 612 "client.c"
	} else {
#line 88 "client.vala"
		_tmp16_ = self->priv->preedit_visible != visible;
#line 616 "client.c"
	}
#line 87 "client.vala"
	if (_tmp16_) {
#line 620 "client.c"
		const gchar* _tmp22_;
		gchar* _tmp23_;
		FepGAttribute* _tmp24_;
		FepGAttribute* _tmp25_;
#line 89 "client.vala"
		_tmp22_ = _preedit;
#line 89 "client.vala"
		_tmp23_ = g_strdup (_tmp22_);
#line 89 "client.vala"
		_g_free0 (self->priv->preedit);
#line 89 "client.vala"
		self->priv->preedit = _tmp23_;
#line 90 "client.vala"
		_tmp24_ = attr;
#line 90 "client.vala"
		_tmp25_ = __vala_FepGAttribute_copy0 (_tmp24_);
#line 90 "client.vala"
		__vala_FepGAttribute_free0 (self->priv->preedit_attr);
#line 90 "client.vala"
		self->priv->preedit_attr = _tmp25_;
#line 91 "client.vala"
		if (visible) {
#line 92 "client.vala"
			_client_ibus_show_preedit_text (self);
#line 645 "client.c"
		} else {
#line 94 "client.vala"
			_client_ibus_hide_preedit_text (self);
#line 649 "client.c"
		}
	}
#line 69 "client.vala"
	__vala_FepGAttribute_free0 (attr);
#line 69 "client.vala"
	_g_object_unref0 (attrs);
#line 69 "client.vala"
	_g_free0 (_preedit);
#line 658 "client.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1501 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1501 "glib-2.0.vapi"
	end = _tmp0_;
#line 1502 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1502 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1503 "glib-2.0.vapi"
		result = maxlen;
#line 1503 "glib-2.0.vapi"
		return result;
#line 681 "client.c"
	} else {
		gchar* _tmp2_;
#line 1505 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1505 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1505 "glib-2.0.vapi"
		return result;
#line 690 "client.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1512 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1514 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 709 "client.c"
	} else {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 713 "client.c"
	}
#line 1514 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1516 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 719 "client.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1518 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1518 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1518 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 729 "client.c"
	}
#line 1521 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1522 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1523 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 737 "client.c"
	} else {
#line 1525 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 741 "client.c"
	}
#line 1527 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1528 "glib-2.0.vapi"
		len = string_length - offset;
#line 747 "client.c"
	}
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1531 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1531 "glib-2.0.vapi"
	result = _tmp3_;
#line 1531 "glib-2.0.vapi"
	return result;
#line 757 "client.c"
}

static gchar*
client_format_indicator (Client* self)
{
	IBusEngineDesc* desc = NULL;
	IBusInputContext* _tmp0_;
	IBusEngineDesc* _tmp1_;
	IBusEngineDesc* _tmp2_;
	IBusEngineDesc* _tmp3_;
	gchar* result;
#line 99 "client.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 100 "client.vala"
	_tmp0_ = self->priv->context;
#line 100 "client.vala"
	_tmp1_ = ibus_input_context_get_engine (_tmp0_);
#line 100 "client.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 100 "client.vala"
	desc = _tmp2_;
#line 101 "client.vala"
	_tmp3_ = desc;
#line 101 "client.vala"
	if (_tmp3_ != NULL) {
#line 783 "client.c"
		gchar* symbol = NULL;
		IBusEngineDesc* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		const gchar* _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
		const gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
#line 102 "client.vala"
		_tmp4_ = desc;
#line 102 "client.vala"
		_tmp5_ = ibus_engine_desc_get_symbol (_tmp4_);
#line 102 "client.vala"
		_tmp6_ = _tmp5_;
#line 102 "client.vala"
		_tmp7_ = g_strdup (_tmp6_);
#line 102 "client.vala"
		symbol = _tmp7_;
#line 103 "client.vala"
		_tmp8_ = symbol;
#line 103 "client.vala"
		_tmp9_ = strlen (_tmp8_);
#line 103 "client.vala"
		_tmp10_ = _tmp9_;
#line 103 "client.vala"
		if (_tmp10_ == 0) {
#line 815 "client.c"
			IBusEngineDesc* _tmp11_;
			const gchar* _tmp12_;
			const gchar* _tmp13_;
			gchar* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
			gchar* _tmp17_;
			gchar* _tmp18_;
#line 104 "client.vala"
			_tmp11_ = desc;
#line 104 "client.vala"
			_tmp12_ = ibus_engine_desc_get_name (_tmp11_);
#line 104 "client.vala"
			_tmp13_ = _tmp12_;
#line 104 "client.vala"
			_tmp14_ = g_utf8_strup (_tmp13_, (gssize) -1);
#line 104 "client.vala"
			_tmp15_ = _tmp14_;
#line 104 "client.vala"
			_tmp16_ = g_strconcat (_tmp15_, "??", NULL);
#line 104 "client.vala"
			_tmp17_ = _tmp16_;
#line 104 "client.vala"
			_tmp18_ = string_substring (_tmp17_, (glong) 0, (glong) 2);
#line 104 "client.vala"
			_g_free0 (symbol);
#line 104 "client.vala"
			symbol = _tmp18_;
#line 104 "client.vala"
			_g_free0 (_tmp17_);
#line 104 "client.vala"
			_g_free0 (_tmp15_);
#line 848 "client.c"
		}
#line 106 "client.vala"
		_tmp19_ = symbol;
#line 106 "client.vala"
		_tmp20_ = g_strconcat ("[", _tmp19_, NULL);
#line 106 "client.vala"
		_tmp21_ = _tmp20_;
#line 106 "client.vala"
		_tmp22_ = g_strconcat (_tmp21_, "] ", NULL);
#line 106 "client.vala"
		_tmp23_ = _tmp22_;
#line 106 "client.vala"
		_g_free0 (_tmp21_);
#line 106 "client.vala"
		result = _tmp23_;
#line 106 "client.vala"
		_g_free0 (symbol);
#line 106 "client.vala"
		_g_object_unref0 (desc);
#line 106 "client.vala"
		return result;
#line 870 "client.c"
	} else {
		gchar* _tmp24_;
#line 108 "client.vala"
		_tmp24_ = g_strdup ("[??] ");
#line 108 "client.vala"
		result = _tmp24_;
#line 108 "client.vala"
		_g_object_unref0 (desc);
#line 108 "client.vala"
		return result;
#line 881 "client.c"
	}
}

static void
client_update_status (Client* self)
{
	GString* builder = NULL;
	GString* _tmp0_;
	GString* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	FepGAttribute* attr = NULL;
	gboolean _tmp39_ = FALSE;
	const gchar* _tmp40_;
	GString* _tmp41_;
	const gchar* _tmp42_;
#line 112 "client.vala"
	g_return_if_fail (self != NULL);
#line 113 "client.vala"
	_tmp0_ = g_string_new ("");
#line 113 "client.vala"
	builder = _tmp0_;
#line 117 "client.vala"
	_tmp1_ = builder;
#line 117 "client.vala"
	_tmp2_ = client_format_indicator (self);
#line 117 "client.vala"
	_tmp3_ = _tmp2_;
#line 117 "client.vala"
	g_string_append (_tmp1_, _tmp3_);
#line 117 "client.vala"
	_g_free0 (_tmp3_);
#line 126 "client.vala"
	attr = NULL;
#line 127 "client.vala"
	if (self->priv->lookup_table_visible) {
#line 918 "client.c"
		guint pages = 0U;
		IBusLookupTable* _tmp4_;
		IBusLookupTable* _tmp5_;
		guint start = 0U;
		IBusLookupTable* _tmp6_;
		guint end = 0U;
		IBusLookupTable* _tmp7_;
		IBusLookupTable* _tmp8_;
#line 128 "client.vala"
		_tmp4_ = self->priv->lookup_table;
#line 128 "client.vala"
		_tmp5_ = self->priv->lookup_table;
#line 128 "client.vala"
		pages = _tmp4_->cursor_pos / _tmp5_->page_size;
#line 130 "client.vala"
		_tmp6_ = self->priv->lookup_table;
#line 130 "client.vala"
		start = pages * _tmp6_->page_size;
#line 131 "client.vala"
		_tmp7_ = self->priv->lookup_table;
#line 131 "client.vala"
		_tmp8_ = self->priv->lookup_table;
#line 131 "client.vala"
		end = MIN (start + _tmp7_->page_size, ibus_lookup_table_get_number_of_candidates (_tmp8_));
#line 943 "client.c"
		{
			guint index = 0U;
#line 134 "client.vala"
			index = start;
#line 948 "client.c"
			{
				gboolean _tmp9_ = FALSE;
#line 134 "client.vala"
				_tmp9_ = TRUE;
#line 134 "client.vala"
				while (TRUE) {
#line 955 "client.c"
					IBusText* label = NULL;
					IBusLookupTable* _tmp11_;
					IBusText* _tmp12_;
					IBusText* _tmp13_;
					IBusText* candidate = NULL;
					IBusLookupTable* _tmp14_;
					IBusText* _tmp15_;
					IBusText* _tmp16_;
					gchar* _tmp17_ = NULL;
					IBusText* _tmp18_;
					gchar* label_text = NULL;
					gchar* _tmp23_;
					gchar* text = NULL;
					const gchar* _tmp24_;
					IBusText* _tmp25_;
					const gchar* _tmp26_;
					gchar* _tmp27_;
					gboolean _tmp28_ = FALSE;
					IBusLookupTable* _tmp29_;
					GString* _tmp36_;
					const gchar* _tmp37_;
#line 134 "client.vala"
					if (!_tmp9_) {
#line 979 "client.c"
						guint _tmp10_;
#line 134 "client.vala"
						_tmp10_ = index;
#line 134 "client.vala"
						index = _tmp10_ + 1;
#line 985 "client.c"
					}
#line 134 "client.vala"
					_tmp9_ = FALSE;
#line 134 "client.vala"
					if (!(index < end)) {
#line 134 "client.vala"
						break;
#line 993 "client.c"
					}
#line 135 "client.vala"
					_tmp11_ = self->priv->lookup_table;
#line 135 "client.vala"
					_tmp12_ = ibus_lookup_table_get_label (_tmp11_, index - start);
#line 135 "client.vala"
					_tmp13_ = _g_object_ref0 (_tmp12_);
#line 135 "client.vala"
					label = _tmp13_;
#line 136 "client.vala"
					_tmp14_ = self->priv->lookup_table;
#line 136 "client.vala"
					_tmp15_ = ibus_lookup_table_get_candidate (_tmp14_, index);
#line 136 "client.vala"
					_tmp16_ = _g_object_ref0 (_tmp15_);
#line 136 "client.vala"
					candidate = _tmp16_;
#line 137 "client.vala"
					_tmp18_ = label;
#line 137 "client.vala"
					if (_tmp18_ != NULL) {
#line 1015 "client.c"
						IBusText* _tmp19_;
						const gchar* _tmp20_;
						gchar* _tmp21_;
#line 138 "client.vala"
						_tmp19_ = label;
#line 138 "client.vala"
						_tmp20_ = ibus_text_get_text (_tmp19_);
#line 138 "client.vala"
						_tmp21_ = g_strdup (_tmp20_);
#line 138 "client.vala"
						_g_free0 (_tmp17_);
#line 138 "client.vala"
						_tmp17_ = _tmp21_;
#line 1029 "client.c"
					} else {
						gchar* _tmp22_;
#line 139 "client.vala"
						_tmp22_ = g_strdup_printf ("%u", (index - start) + 1);
#line 139 "client.vala"
						_g_free0 (_tmp17_);
#line 139 "client.vala"
						_tmp17_ = _tmp22_;
#line 1038 "client.c"
					}
#line 137 "client.vala"
					_tmp23_ = g_strdup (_tmp17_);
#line 137 "client.vala"
					label_text = _tmp23_;
#line 140 "client.vala"
					_tmp24_ = label_text;
#line 140 "client.vala"
					_tmp25_ = candidate;
#line 140 "client.vala"
					_tmp26_ = ibus_text_get_text (_tmp25_);
#line 140 "client.vala"
					_tmp27_ = g_strdup_printf ("%s:%s", _tmp24_, _tmp26_);
#line 140 "client.vala"
					text = _tmp27_;
#line 142 "client.vala"
					_tmp29_ = self->priv->lookup_table;
#line 142 "client.vala"
					if (ibus_lookup_table_is_cursor_visible (_tmp29_)) {
#line 1058 "client.c"
						IBusLookupTable* _tmp30_;
#line 143 "client.vala"
						_tmp30_ = self->priv->lookup_table;
#line 143 "client.vala"
						_tmp28_ = index == ibus_lookup_table_get_cursor_pos (_tmp30_);
#line 1064 "client.c"
					} else {
#line 142 "client.vala"
						_tmp28_ = FALSE;
#line 1068 "client.c"
					}
#line 142 "client.vala"
					if (_tmp28_) {
#line 1072 "client.c"
						gint start_index = 0;
						GString* _tmp31_;
						const gchar* _tmp32_;
						const gchar* _tmp33_;
						FepGAttribute _tmp34_ = {0};
						FepGAttribute* _tmp35_;
#line 144 "client.vala"
						_tmp31_ = builder;
#line 144 "client.vala"
						_tmp32_ = _tmp31_->str;
#line 144 "client.vala"
						start_index = g_utf8_strlen (_tmp32_, (gssize) -1);
#line 145 "client.vala"
						_tmp33_ = text;
#line 145 "client.vala"
						memset (&_tmp34_, 0, sizeof (FepGAttribute));
#line 145 "client.vala"
						_tmp34_.type = FEP_G_ATTR_TYPE_STANDOUT;
#line 145 "client.vala"
						_tmp34_.value = (guint) 1;
#line 145 "client.vala"
						_tmp34_.start_index = (guint) start_index;
#line 145 "client.vala"
						_tmp34_.end_index = (guint) (start_index + g_utf8_strlen (_tmp33_, (gssize) -1));
#line 145 "client.vala"
						_tmp35_ = __vala_FepGAttribute_copy0 (&_tmp34_);
#line 145 "client.vala"
						__vala_FepGAttribute_free0 (attr);
#line 145 "client.vala"
						attr = _tmp35_;
#line 1103 "client.c"
					}
#line 152 "client.vala"
					_tmp36_ = builder;
#line 152 "client.vala"
					_tmp37_ = text;
#line 152 "client.vala"
					g_string_append (_tmp36_, _tmp37_);
#line 153 "client.vala"
					if (index < (end - 1)) {
#line 1113 "client.c"
						GString* _tmp38_;
#line 154 "client.vala"
						_tmp38_ = builder;
#line 154 "client.vala"
						g_string_append_c (_tmp38_, ' ');
#line 1119 "client.c"
					}
#line 134 "client.vala"
					_g_free0 (text);
#line 134 "client.vala"
					_g_free0 (label_text);
#line 134 "client.vala"
					_g_free0 (_tmp17_);
#line 134 "client.vala"
					_g_object_unref0 (candidate);
#line 134 "client.vala"
					_g_object_unref0 (label);
#line 1131 "client.c"
				}
			}
		}
	}
#line 157 "client.vala"
	_tmp40_ = self->priv->status;
#line 157 "client.vala"
	_tmp41_ = builder;
#line 157 "client.vala"
	_tmp42_ = _tmp41_->str;
#line 157 "client.vala"
	if (g_strcmp0 (_tmp40_, _tmp42_) != 0) {
#line 157 "client.vala"
		_tmp39_ = TRUE;
#line 1146 "client.c"
	} else {
		FepGAttribute* _tmp43_;
		FepGAttribute* _tmp44_;
#line 157 "client.vala"
		_tmp43_ = self->priv->status_attr;
#line 157 "client.vala"
		_tmp44_ = attr;
#line 157 "client.vala"
		_tmp39_ = _fep_g_attribute_equal (_tmp43_, _tmp44_) != TRUE;
#line 1156 "client.c"
	}
#line 157 "client.vala"
	if (_tmp39_) {
#line 1160 "client.c"
		GString* _tmp45_;
		const gchar* _tmp46_;
		FepGAttribute* _tmp47_;
		GString* _tmp48_;
		const gchar* _tmp49_;
		gchar* _tmp50_;
		FepGAttribute* _tmp51_;
		FepGAttribute* _tmp52_;
#line 158 "client.vala"
		_tmp45_ = builder;
#line 158 "client.vala"
		_tmp46_ = _tmp45_->str;
#line 158 "client.vala"
		_tmp47_ = attr;
#line 158 "client.vala"
		fep_g_client_set_status_text ((FepGClient*) self, _tmp46_, _tmp47_);
#line 159 "client.vala"
		_tmp48_ = builder;
#line 159 "client.vala"
		_tmp49_ = _tmp48_->str;
#line 159 "client.vala"
		_tmp50_ = g_strdup (_tmp49_);
#line 159 "client.vala"
		_g_free0 (self->priv->status);
#line 159 "client.vala"
		self->priv->status = _tmp50_;
#line 160 "client.vala"
		_tmp51_ = attr;
#line 160 "client.vala"
		_tmp52_ = __vala_FepGAttribute_copy0 (_tmp51_);
#line 160 "client.vala"
		__vala_FepGAttribute_free0 (self->priv->status_attr);
#line 160 "client.vala"
		self->priv->status_attr = _tmp52_;
#line 1195 "client.c"
	}
#line 112 "client.vala"
	__vala_FepGAttribute_free0 (attr);
#line 112 "client.vala"
	_g_string_free0 (builder);
#line 1201 "client.c"
}

static void
_client_ibus_show_lookup_table (Client* self)
{
#line 164 "client.vala"
	g_return_if_fail (self != NULL);
#line 165 "client.vala"
	self->priv->lookup_table_visible = TRUE;
#line 166 "client.vala"
	client_update_status (self);
#line 1213 "client.c"
}

static void
_client_ibus_hide_lookup_table (Client* self)
{
	gboolean _tmp0_ = FALSE;
	Options _tmp1_;
#line 169 "client.vala"
	g_return_if_fail (self != NULL);
#line 170 "client.vala"
	self->priv->lookup_table_visible = FALSE;
#line 173 "client.vala"
	_tmp1_ = self->priv->opts;
#line 173 "client.vala"
	if (_tmp1_.preedit_style == PREEDIT_STYLE_ROOT) {
#line 173 "client.vala"
		_tmp0_ = self->priv->preedit_visible;
#line 1231 "client.c"
	} else {
#line 173 "client.vala"
		_tmp0_ = FALSE;
#line 1235 "client.c"
	}
#line 173 "client.vala"
	if (_tmp0_) {
#line 174 "client.vala"
		_client_ibus_show_preedit_text (self);
#line 1241 "client.c"
	} else {
#line 176 "client.vala"
		client_update_status (self);
#line 1245 "client.c"
	}
}

static void
_client_ibus_update_lookup_table (Client* self,
                                  IBusLookupTable* lookup_table,
                                  gboolean visible)
{
	IBusLookupTable* _tmp0_;
#line 179 "client.vala"
	g_return_if_fail (self != NULL);
#line 179 "client.vala"
	g_return_if_fail (lookup_table != NULL);
#line 182 "client.vala"
	_tmp0_ = _g_object_ref0 (lookup_table);
#line 182 "client.vala"
	_g_object_unref0 (self->priv->lookup_table);
#line 182 "client.vala"
	self->priv->lookup_table = _tmp0_;
#line 183 "client.vala"
	if (visible) {
#line 184 "client.vala"
		_client_ibus_show_lookup_table (self);
#line 1269 "client.c"
	} else {
#line 186 "client.vala"
		_client_ibus_hide_lookup_table (self);
#line 1273 "client.c"
	}
}

static void
_client_ibus_global_engine_changed (Client* self,
                                    const gchar* name)
{
#line 190 "client.vala"
	g_return_if_fail (self != NULL);
#line 190 "client.vala"
	g_return_if_fail (name != NULL);
#line 191 "client.vala"
	client_update_status (self);
#line 1287 "client.c"
}

static gboolean
client_real_filter_key_event (FepGClient* base,
                              guint keyval,
                              guint modifiers)
{
	Client * self;
	IBusInputContext* _tmp0_;
	gboolean result;
#line 205 "client.vala"
	self = (Client*) base;
#line 208 "client.vala"
	_tmp0_ = self->priv->context;
#line 208 "client.vala"
	if (_tmp0_ != NULL) {
#line 1304 "client.c"
		gboolean retval = FALSE;
		IBusInputContext* _tmp1_;
#line 209 "client.vala"
		_tmp1_ = self->priv->context;
#line 209 "client.vala"
		retval = ibus_input_context_process_key_event (_tmp1_, (guint32) keyval, (guint32) 0, (guint32) modifiers);
#line 210 "client.vala"
		if (retval) {
#line 211 "client.vala"
			client_update_status (self);
#line 1315 "client.c"
		}
#line 212 "client.vala"
		result = retval;
#line 212 "client.vala"
		return result;
#line 1321 "client.c"
	}
#line 214 "client.vala"
	result = FALSE;
#line 214 "client.vala"
	return result;
#line 1327 "client.c"
}

static gboolean
client_watch_func (Client* self,
                   GIOChannel* source,
                   GIOCondition condition)
{
	gboolean result;
#line 217 "client.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 217 "client.vala"
	g_return_val_if_fail (source != NULL, FALSE);
#line 218 "client.vala"
	fep_g_client_dispatch ((FepGClient*) self);
#line 219 "client.vala"
	result = TRUE;
#line 219 "client.vala"
	return result;
#line 1346 "client.c"
}

static void
__client_ibus_commit_text_ibus_input_context_commit_text (IBusInputContext* _sender,
                                                          IBusText* p0,
                                                          gpointer self)
{
#line 223 "client.vala"
	_client_ibus_commit_text ((Client*) self, p0);
#line 1356 "client.c"
}

static void
__client_ibus_show_preedit_text_ibus_input_context_show_preedit_text (IBusInputContext* _sender,
                                                                      gpointer self)
{
#line 224 "client.vala"
	_client_ibus_show_preedit_text ((Client*) self);
#line 1365 "client.c"
}

static void
__client_ibus_hide_preedit_text_ibus_input_context_hide_preedit_text (IBusInputContext* _sender,
                                                                      gpointer self)
{
#line 225 "client.vala"
	_client_ibus_hide_preedit_text ((Client*) self);
#line 1374 "client.c"
}

static void
__client_ibus_update_preedit_text_ibus_input_context_update_preedit_text (IBusInputContext* _sender,
                                                                          IBusText* p0,
                                                                          guint p1,
                                                                          gboolean p2,
                                                                          gpointer self)
{
#line 226 "client.vala"
	_client_ibus_update_preedit_text ((Client*) self, p0, p1, p2);
#line 1386 "client.c"
}

static void
__client_ibus_show_lookup_table_ibus_input_context_show_lookup_table (IBusInputContext* _sender,
                                                                      gpointer self)
{
#line 228 "client.vala"
	_client_ibus_show_lookup_table ((Client*) self);
#line 1395 "client.c"
}

static void
__client_ibus_hide_lookup_table_ibus_input_context_hide_lookup_table (IBusInputContext* _sender,
                                                                      gpointer self)
{
#line 229 "client.vala"
	_client_ibus_hide_lookup_table ((Client*) self);
#line 1404 "client.c"
}

static void
__client_ibus_update_lookup_table_ibus_input_context_update_lookup_table (IBusInputContext* _sender,
                                                                          IBusLookupTable* p0,
                                                                          gboolean p1,
                                                                          gpointer self)
{
#line 230 "client.vala"
	_client_ibus_update_lookup_table ((Client*) self, p0, p1);
#line 1415 "client.c"
}

static void
client_create_input_context_done (Client* self)
{
	IBusInputContext* _tmp0_;
	IBusInputContext* _tmp1_;
	IBusInputContext* _tmp2_;
	IBusInputContext* _tmp3_;
	IBusInputContext* _tmp4_;
	IBusInputContext* _tmp5_;
	IBusInputContext* _tmp6_;
	IBusInputContext* _tmp7_;
	IBusInputContext* _tmp8_;
#line 222 "client.vala"
	g_return_if_fail (self != NULL);
#line 223 "client.vala"
	_tmp0_ = self->priv->context;
#line 223 "client.vala"
	g_signal_connect_object (_tmp0_, "commit-text", (GCallback) __client_ibus_commit_text_ibus_input_context_commit_text, self, 0);
#line 224 "client.vala"
	_tmp1_ = self->priv->context;
#line 224 "client.vala"
	g_signal_connect_object (_tmp1_, "show-preedit-text", (GCallback) __client_ibus_show_preedit_text_ibus_input_context_show_preedit_text, self, 0);
#line 225 "client.vala"
	_tmp2_ = self->priv->context;
#line 225 "client.vala"
	g_signal_connect_object (_tmp2_, "hide-preedit-text", (GCallback) __client_ibus_hide_preedit_text_ibus_input_context_hide_preedit_text, self, 0);
#line 226 "client.vala"
	_tmp3_ = self->priv->context;
#line 226 "client.vala"
	g_signal_connect_object (_tmp3_, "update-preedit-text", (GCallback) __client_ibus_update_preedit_text_ibus_input_context_update_preedit_text, self, 0);
#line 228 "client.vala"
	_tmp4_ = self->priv->context;
#line 228 "client.vala"
	g_signal_connect_object (_tmp4_, "show-lookup-table", (GCallback) __client_ibus_show_lookup_table_ibus_input_context_show_lookup_table, self, 0);
#line 229 "client.vala"
	_tmp5_ = self->priv->context;
#line 229 "client.vala"
	g_signal_connect_object (_tmp5_, "hide-lookup-table", (GCallback) __client_ibus_hide_lookup_table_ibus_input_context_hide_lookup_table, self, 0);
#line 230 "client.vala"
	_tmp6_ = self->priv->context;
#line 230 "client.vala"
	g_signal_connect_object (_tmp6_, "update-lookup-table", (GCallback) __client_ibus_update_lookup_table_ibus_input_context_update_lookup_table, self, 0);
#line 233 "client.vala"
	_tmp7_ = self->priv->context;
#line 233 "client.vala"
	ibus_input_context_set_capabilities (_tmp7_, (guint32) (((IBUS_CAP_PREEDIT_TEXT | IBUS_CAP_LOOKUP_TABLE) | IBUS_CAP_AUXILIARY_TEXT) | IBUS_CAP_FOCUS));
#line 237 "client.vala"
	_tmp8_ = self->priv->context;
#line 237 "client.vala"
	ibus_input_context_focus_in (_tmp8_);
#line 241 "client.vala"
	client_update_status (self);
#line 1470 "client.c"
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 250 "client.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 250 "client.vala"
	return _data1_;
#line 1480 "client.c"
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 250 "client.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 1490 "client.c"
		Client* self;
#line 250 "client.vala"
		self = _data1_->self;
#line 250 "client.vala"
		_g_object_unref0 (_data1_->bus);
#line 250 "client.vala"
		_g_object_unref0 (self);
#line 250 "client.vala"
		g_slice_free (Block1Data, _data1_);
#line 1500 "client.c"
	}
}

static void
__client_ibus_global_engine_changed_ibus_bus_global_engine_changed (IBusBus* _sender,
                                                                    const gchar* p0,
                                                                    gpointer self)
{
#line 256 "client.vala"
	_client_ibus_global_engine_changed ((Client*) self, p0);
#line 1511 "client.c"
}

static void
__lambda4_ (Block1Data* _data1_,
            GObject* obj,
            GAsyncResult* res)
{
	Client* self;
	GError* _inner_error0_ = NULL;
#line 258 "client.vala"
	self = _data1_->self;
#line 258 "client.vala"
	g_return_if_fail (res != NULL);
#line 1525 "client.c"
	{
		IBusInputContext* _tmp0_ = NULL;
		IBusInputContext* _tmp1_;
		IBusInputContext* _tmp2_;
#line 260 "client.vala"
		_tmp1_ = ibus_bus_create_input_context_async_finish (_data1_->bus, res, &_inner_error0_);
#line 260 "client.vala"
		_tmp0_ = _tmp1_;
#line 260 "client.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1536 "client.c"
			goto __catch0_g_error;
		}
#line 260 "client.vala"
		_tmp2_ = _g_object_ref0 (_tmp0_);
#line 260 "client.vala"
		_g_object_unref0 (self->priv->context);
#line 260 "client.vala"
		self->priv->context = _tmp2_;
#line 261 "client.vala"
		client_create_input_context_done (self);
#line 1547 "client.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
#line 259 "client.vala"
		e = _inner_error0_;
#line 259 "client.vala"
		_inner_error0_ = NULL;
#line 263 "client.vala"
		_tmp3_ = e;
#line 263 "client.vala"
		_tmp4_ = _tmp3_->message;
#line 263 "client.vala"
		g_warning ("client.vala:263: can't create input context: %s", _tmp4_);
#line 259 "client.vala"
		_g_error_free0 (e);
#line 1567 "client.c"
	}
	__finally0:
#line 259 "client.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 259 "client.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 259 "client.vala"
		g_clear_error (&_inner_error0_);
#line 259 "client.vala"
		return;
#line 1578 "client.c"
	}
}

static void
___lambda4__gasync_ready_callback (GObject* source_object,
                                   GAsyncResult* res,
                                   gpointer self)
{
#line 258 "client.vala"
	__lambda4_ (self, source_object, res);
#line 258 "client.vala"
	block1_data_unref (self);
#line 1591 "client.c"
}

static gboolean
_client_watch_func_gio_func (GIOChannel* source,
                             GIOCondition condition,
                             gpointer self)
{
	gboolean result;
	result = client_watch_func ((Client*) self, source, condition);
#line 268 "client.vala"
	return result;
#line 1603 "client.c"
}

Client*
client_construct (GType object_type,
                  IBusBus* bus,
                  Options* opts,
                  GError** error)
{
	Client * self = NULL;
	Block1Data* _data1_;
	IBusBus* _tmp0_;
	Options _tmp1_;
	GIOChannel* channel = NULL;
	GIOChannel* _tmp2_;
	GIOChannel* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 250 "client.vala"
	g_return_val_if_fail (bus != NULL, NULL);
#line 250 "client.vala"
	g_return_val_if_fail (opts != NULL, NULL);
#line 250 "client.vala"
	_data1_ = g_slice_new0 (Block1Data);
#line 250 "client.vala"
	_data1_->_ref_count_ = 1;
#line 250 "client.vala"
	_tmp0_ = _g_object_ref0 (bus);
#line 250 "client.vala"
	_g_object_unref0 (_data1_->bus);
#line 250 "client.vala"
	_data1_->bus = _tmp0_;
#line 251 "client.vala"
	self = (Client*) g_object_new (object_type, "address", NULL, NULL);
#line 251 "client.vala"
	_data1_->self = g_object_ref (self);
#line 252 "client.vala"
	g_initable_init ((GInitable*) self, NULL, &_inner_error0_);
#line 252 "client.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 252 "client.vala"
		g_propagate_error (error, _inner_error0_);
#line 252 "client.vala"
		block1_data_unref (_data1_);
#line 252 "client.vala"
		_data1_ = NULL;
#line 252 "client.vala"
		_g_object_unref0 (self);
#line 252 "client.vala"
		return NULL;
#line 1652 "client.c"
	}
#line 253 "client.vala"
	_tmp1_ = *opts;
#line 253 "client.vala"
	self->priv->opts = _tmp1_;
#line 256 "client.vala"
	g_signal_connect_object (_data1_->bus, "global-engine-changed", (GCallback) __client_ibus_global_engine_changed_ibus_bus_global_engine_changed, self, 0);
#line 258 "client.vala"
	ibus_bus_create_input_context_async (_data1_->bus, "ibus-fep", -1, NULL, ___lambda4__gasync_ready_callback, block1_data_ref (_data1_));
#line 267 "client.vala"
	_tmp2_ = g_io_channel_unix_new (fep_g_client_get_poll_fd ((FepGClient*) self));
#line 267 "client.vala"
	channel = _tmp2_;
#line 268 "client.vala"
	_tmp3_ = channel;
#line 268 "client.vala"
	g_io_add_watch (_tmp3_, G_IO_IN, _client_watch_func_gio_func, self);
#line 250 "client.vala"
	_g_io_channel_unref0 (channel);
#line 250 "client.vala"
	block1_data_unref (_data1_);
#line 250 "client.vala"
	_data1_ = NULL;
#line 250 "client.vala"
	return self;
#line 1678 "client.c"
}

Client*
client_new (IBusBus* bus,
            Options* opts,
            GError** error)
{
#line 250 "client.vala"
	return client_construct (TYPE_CLIENT, bus, opts, error);
#line 1688 "client.c"
}

static void
client_class_init (ClientClass * klass,
                   gpointer klass_data)
{
#line 29 "client.vala"
	client_parent_class = g_type_class_peek_parent (klass);
#line 29 "client.vala"
	g_type_class_adjust_private_offset (klass, &Client_private_offset);
#line 29 "client.vala"
	((FepGClientClass *) klass)->filter_key_event = (gboolean (*) (FepGClient*, guint, guint)) client_real_filter_key_event;
#line 29 "client.vala"
	G_OBJECT_CLASS (klass)->finalize = client_finalize;
#line 1703 "client.c"
}

static void
client_instance_init (Client * self,
                      gpointer klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 29 "client.vala"
	self->priv = client_get_instance_private (self);
#line 30 "client.vala"
	self->priv->context = NULL;
#line 32 "client.vala"
	self->priv->preedit_visible = FALSE;
#line 33 "client.vala"
	self->priv->lookup_table_visible = FALSE;
#line 36 "client.vala"
	_tmp0_ = g_strdup ("");
#line 36 "client.vala"
	self->priv->preedit = _tmp0_;
#line 38 "client.vala"
	_tmp1_ = g_strdup ("");
#line 38 "client.vala"
	self->priv->status = _tmp1_;
#line 1728 "client.c"
}

static void
client_finalize (GObject * obj)
{
	Client * self;
#line 29 "client.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CLIENT, Client);
#line 30 "client.vala"
	_g_object_unref0 (self->priv->context);
#line 31 "client.vala"
	_g_object_unref0 (self->priv->lookup_table);
#line 36 "client.vala"
	_g_free0 (self->priv->preedit);
#line 37 "client.vala"
	__vala_FepGAttribute_free0 (self->priv->preedit_attr);
#line 38 "client.vala"
	_g_free0 (self->priv->status);
#line 39 "client.vala"
	__vala_FepGAttribute_free0 (self->priv->status_attr);
#line 29 "client.vala"
	G_OBJECT_CLASS (client_parent_class)->finalize (obj);
#line 1751 "client.c"
}

static GType
client_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ClientClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) client_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Client), 0, (GInstanceInitFunc) client_instance_init, NULL };
	GType client_type_id;
	client_type_id = g_type_register_static (fep_g_client_get_type (), "Client", &g_define_type_info, 0);
	Client_private_offset = g_type_add_instance_private (client_type_id, sizeof (ClientPrivate));
	return client_type_id;
}

GType
client_get_type (void)
{
	static volatile gsize client_type_id__once = 0;
	if (g_once_init_enter (&client_type_id__once)) {
		GType client_type_id;
		client_type_id = client_get_type_once ();
		g_once_init_leave (&client_type_id__once, client_type_id);
	}
	return client_type_id__once;
}

